Program(icon:"lib/ico.ico")
    Uses Pure2d, Keyset

{*
    SoCoder Wednesday Workshop #104
    The 'The Sequel Challenge' Sequel Challenge
    
    Chosen WW: Super Roadster by Jayenkai for Workshop #084
    (http://socoder.net/index.php?a=15&e=238)
    
    Sequel by HoboBen
*}

Var
    MileCount : Integer
    RAngGo, RAng, RWide : Integer
    PAng : Real
    PX, PY : Real
    Canvas,Scores,Car,Lights,SuRoad,Two : Element
    t,r : Element
    Speed, Accel : Real
    MilliStart : integer

Procedure Init()
Begin
    Randomize
    
    PAng    =  90.000
    PX      = 100.000
    PY      = 100.000
    Speed   = 0.000
    Accel   = 0.100
    
    RAng    = 9000
    RWide   = 40
    RAngGo  = 0
    
    Car = LoadImage("lib/car.png")
    SuRoad = LoadImage("lib/suroad.png")
    ImageAlpha(SuRoad,230)
    Two = LoadImage("lib/two.png")
    Lights = LoadImage("lib/lights.png")
    ImageAlpha(Lights,150)    
    Canvas = CreateImage(200,200)
    Scores = CreateImage(400,400)        
    SetFont("arial",14,0,Scores)
    PenColor(ToRGBA(255,255,255),Scores)
    ImageAlpha(Scores,150)
    
    ResizeFilter(P2D_RFLINEAR, Canvas)
    t = CreateTransform
    r = CreateTransform
    TransformScale(t, 2, 2)
    AADraw(1)
     
    RedrawScores()
    
    MilliStart=Millisecs()
End

Procedure RedrawScores()
Begin
    Rect(0,0,400,20,ToRGBA(0,0,0),TRUE,Scores)
    Rect(0,380,400,20,ToRGBA(0,0,0),TRUE,Scores)
    Text(2,0,"Distance Travelled: "+ToInt(MileCount)+" Metres",Scores)
    Text(2,380,"Speed: "+ToInt(Speed)+" Metres/second",Scores)        
End 

Function SecondPassed() : Boolean
Var
    MilliComp
Begin
    MilliComp = Millisecs()-MilliStart
    If (MilliComp > 1000) Then
        MilliStart=Millisecs()
        Result=TRUE
    Else
        Result=FALSE
    Endif

End
    
Begin
    SetAppName("Super Roadster II")
    OpenScreen(400,400,24,FALSE,COB_SHOWBORDER+COB_SHOWCLOSE+COB_SHOWMINIMIZE)
    Init()
    
    While not ExitRequested
        Cls(ToRGBA(0,0,0))
        Cls(ToRGBA(0,160,0),Canvas)
        
        If SecondPassed() then MileCount=MileCount+Speed
        Speed = Speed + Accel
        If (Speed > 20) then Accel=Accel*0.992
        RedrawScores()
        
        RAng=RAng+RAngGo    
        If Rand(1,50)=1 Then RAngGo=Rand(-10,10)*1.8*Speed
        If Rand(1,50)=1 Then RAngGo=Rand(-10,10)*1.2*Speed
        If Rand(1,50)=1 Then RAngGo=Rand(-10,10)*Speed
        PX=PX+Sin(PAng)*2.1
        PY=PY-Cos(PAng)*2.1
        PX=PX-Sin(ToReal(RAng)/100)*2
        PY=PY+Cos(ToReal(RAng)/100)*2
        
        If ( ((PX+Sin(PAng)*10)<-40) Or ((PX+Sin(PAng)*10)>200) Or ((PY-Cos(PAng)*10)<-40) Or ((PY-Cos(PAng)*10)>200) )
            RequestExit
        EndIf
        
        Line(100+(Sin((ToReal(RAng)/100))*200)-(Sin(90+(ToReal(RAng)/100))*RWide),100-(Cos((ToReal(RAng)/100))*200)+(Cos(90+(ToReal(RAng)/100))*RWide),100-(Sin((ToReal(RAng)/100))*200)-(Sin(90+(ToReal(RAng)/100))*RWide),100+(Cos((ToReal(RAng)/100))*200)+(Cos(90+(ToReal(RAng)/100))*RWide),ToRGBA(200,200,200),Canvas)
        Line(100+(Sin((ToReal(RAng)/100))*200)-(Sin(270+(ToReal(RAng)/100))*RWide),100-(Cos((ToReal(RAng)/100))*200)+(Cos(270+(ToReal(RAng)/100))*RWide),100-(Sin((ToReal(RAng)/100))*200)-(Sin(270+(ToReal(RAng)/100))*RWide),100+(Cos((ToReal(RAng)/100))*200)+(Cos(270+(ToReal(RAng)/100))*RWide),ToRGBA(200,200,200),Canvas)
        
        FloodFill(100,100, ToRGBA(0,0,0), ToRGBA(0,160,0), false, Canvas)
                 
        TransformClear(r)
        TransformRotate(r,0,0,(-PAng) )
        DrawTransform(Lights,r,PX+Sin(PAng)*70,PY-Cos(PAng)*70,Canvas)        
        TransformClear(r)
        TransformRotate(r,0,0,(-PAng) )
        DrawTransform(Car,r,PX+Sin(PAng)*10,PY-Cos(PAng)*10,Canvas)
        
        PAng=PAng+(ToInt(KeyDown(VK_LEFT))*2)-(ToInt(KeyDown(VK_RIGHT))*2)
        
        DrawTransform(Canvas, t, 0, 0)
        Drawimage(Two,328,293)
        Drawimage(SuRoad,0,320)
        DrawImage(Scores,0,0)                
        Flip        
        Pause(10)
        If Keydown(VK_ESCAPE) then RequestExit    
    Wend
        
    CloseScreen()
    MessageBox("Distance Travelled: "+MileCount+" Metres","Game Over!")
End
